/*!
 * array-random
 *
 * Copyright (c) 2021, Ron Masas <ronmasas@gmail.com>
 * Released under the MIT license.
 */

/**
 * Randomize a given array.
 *
 * @param {Array} array
 *
 * @returns {Array}
 */
function randomize(array) {
  var currentIndex = array.length, temporaryValue, randomIndex;

  while (0 !== currentIndex) {
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1;
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}

/**
 * Expose
 */

// AMD
if (typeof window !== 'undefined' && typeof window.define === 'function' && window.define.amd !== undefined) {
  window.define('array-random', [], function () {
    return randomize;
  });
  // CommonJS
} else if (typeof module !== 'undefined' && module.exports !== undefined) {
  module.exports = randomize;
  // Browser
} else {
  window.randomize = randomize;
};
